-- MasterLootNWOP.lua
-- Author: KiLLerBoy_001



local function GetSlotID(itemEquipLoc,itemType)
	if itemEquipLoc == 'INVTYPE_HEAD' then return 1
	elseif itemEquipLoc == 'INVTYPE_NECK' then return 2
	elseif itemEquipLoc == 'INVTYPE_SHOULDER' then return 3
	elseif itemEquipLoc == 'BODY' then return 4
	elseif itemEquipLoc == 'INVTYPE_CHEST' then return 5
	elseif itemEquipLoc == 'INVTYPE_ROBE' then return 5
	elseif itemEquipLoc == 'INVTYPE_WAIST' then return 6
	elseif itemEquipLoc == 'INVTYPE_LEGS' then return 7
	elseif itemEquipLoc == 'INVTYPE_FEET' then return 8
	elseif itemEquipLoc == 'INVTYPE_WRIST' then return 9
	elseif itemEquipLoc == 'INVTYPE_HAND' then return 10
	elseif itemEquipLoc == 'INVTYPE_FINGER' then return 11 -- and 12
	elseif itemEquipLoc == 'INVTYPE_TRINKET' then return 13 -- and 14
	elseif itemEquipLoc == 'INVTYPE_CLOAK' then return 15
	elseif itemEquipLoc == 'INVTYPE_WEAPON' then return 16
	elseif itemEquipLoc == 'INVTYPE_SHIELD' then return 17
	elseif itemEquipLoc == 'INVTYPE_2HWEAPON' then return 16
	elseif itemEquipLoc == 'INVTYPE_WEAPONMAINHAND' then return 16
	elseif itemEquipLoc == 'INVTYPE_WEAPONOFFHAND' then return 17
	elseif itemEquipLoc == 'INVTYPE_HOLDABLE' then return 17
	elseif itemEquipLoc == 'INVTYPE_RANGED' then return 16
	elseif itemEquipLoc == 'INVTYPE_THROWN' then return 16
	elseif itemEquipLoc == 'INVTYPE_RANGEDRIGHT' then return 16
	elseif itemEquipLoc == 'INVTYPE_RELIC' then return 18 --needs something else 
	elseif itemType =='Gem' then return 18 --needs something else
	else return nil
	end
end

local function ItemLinkToID(Linky)
local _, _, Color, Ltype, Id, Enchant, Gem1, Gem2, Gem3, Gem4,
    Suffix, Unique, LinkLvl, Name = string.find(Linky,
    "|?c?f?f?(%x*)|?H?([^:]*):?(%d+):?(%d*):?(%d*):?(%d*):?(%d*):?(%d*):?(%-?%d*):?(%-?%d*):?(%d*):?(%d*):?(%-?%d*)|?h?%[?([^%[%]]*)%]?|?h?|?r?")
	return Id
end


GlobalItemLink = ""
Name = ""

local MainFrameDesign = {
  bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",  
  edgeFile = "Interface\\FriendsFrame\\UI-Toast-Border",
  tile = true,
  tileSize = 16,
  edgeSize = 8,
  insets = {
    left = 4,
    right = 4,
    top = 4,
    bottom = 4
  }
}

local CloseBut = {
  bgFile = "Interface\\BUTTONS\\UI-Panel-MinimizeButton-Up",  
}

local NWOPMain = CreateFrame("Frame", "NGOP", UIParent)
NWOPMain:SetSize(280, 105);
NWOPMain:SetPoint("BOTTOM", 0, 250)
NWOPMain:SetFrameStrata("TOOLTIP");
NWOPMain:EnableMouse(true)
NWOPMain:SetBackdrop(MainFrameDesign) 
NWOPMain:SetMovable(true)
NWOPMain:RegisterForDrag("LeftButton")
NWOPMain:SetScript("OnDragStart", function(self) NWOPMain:StartMoving() end)
NWOPMain:SetScript("OnDragStop", function(self) NWOPMain:StopMovingOrSizing() end)
NWOPMain:SetScript("OnEnter", function() Tooltip_OnEnter() end)
NWOPMain:SetScript("OnLeave", function() Tooltip_OnLeave() end)
NWOPMain:Hide()


local function Want()
	name, realm = UnitName("player")
	SendChatMessage(name.." Wants: " , "RAID")
	local r = math.random(1,2147483647)
	RandomRoll(1,100)
	NWOPMain:Hide()
end

local function Need()
	name, realm = UnitName("player")
	itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(GlobalItemLink)
    slotId = GetSlotID(itemEquipLoc,itemType)
	if slotId == 18 then 
		local WeaponID = ItemLinkToID(GetInventoryItemLink("player",16))
		local NewRelicID = ItemLinkToID(GlobalItemLink)

			
		if ArtifactFrame and ArtifactFrame:IsVisible() then -- Open frame if required 
			var = true
		else
			var = false 
			SocketInventoryItem(16)
		end
		
		for relicSlotIndex = 1, C_ArtifactUI.GetNumRelicSlots() do
			if C_ArtifactUI.CanApplyRelicItemIDToSlot(NewRelicID, relicSlotIndex) then
			
				CurRelicName, CurRelicIcon, CurRelicType, CurRelicLink = C_ArtifactUI.GetEquippedArtifactRelicInfo(relicSlotIndex) --GetRelicInfo(relicSlotIndex)
				NewRelicName, NewRelicIcon, NewRelicType, NewRelicLink = C_ArtifactUI.GetRelicInfoByItemID(ItemLinkToID(GlobalItemLink));
				
				--CurrentPowers = C_ArtifactUI.GetPowersAffectedByRelicItemLink(CurrelicLink)
				CurPowers = C_ArtifactUI.GetPowersAffectedByRelic(relicSlotIndex)
				NewPowers = C_ArtifactUI.GetPowersAffectedByRelicItemLink(NewRelicLink)
					
				CurSpellLink = C_ArtifactUI.GetPowerHyperlink(CurPowers)
				NewSpellLink = C_ArtifactUI.GetPowerHyperlink(NewPowers)
				
			end
		end
		
		if var==false then  -- Hide frame if required
			HideUIPanel(ArtifactFrame)
		end
		
		print("From: "..CurSpellLink.."  To: "..NewSpellLink) -- if this works then FML and ill get rid of extra addon lua etc		
		
		local Currentlevel = C_ArtifactUI.GetItemLevelIncreaseProvidedByRelic(ItemLinkToID(CurRelicLink)) 
		local NewLevel = C_ArtifactUI.GetItemLevelIncreaseProvidedByRelic(NewRelicID) 
		level = NewLevel - Currentlevel 
		
		if level >= 0 then 
			PosNeg = "+"
		else
			PosNeg = ""
		end
		
		SendChatMessage("Needs: "..PosNeg..level.."   "..NewSpellLink, "RAID")
	elseif slotId == 11 then 
		Curitem = GetInventoryItemLink("player",11)
		Curitem2 = GetInventoryItemLink("player",12)
		SendChatMessage("Need: "..Curitem.." & "..Curitem2, "RAID")
	elseif slotId == 13 then 
		Curitem = GetInventoryItemLink("player",13)
		Curitem2 = GetInventoryItemLink("player",14)
		SendChatMessage("Need: "..Curitem.." & "..Curitem2, "RAID")
	else
		Curitem = GetInventoryItemLink("player",slotId)
		SendChatMessage("Need: "..Curitem, "RAID")
	end
	NWOPMain:Hide()
end


local function Pass()
	NWOPMain:Hide()
end


function Tooltip_OnEnter()
  GameTooltip_SetDefaultAnchor(GameTooltip, NWOPMain)
  GameTooltip:SetPoint("BOTTOM",NWOPMain, -300, 0)
  GameTooltip:SetHyperlink(GlobalItemLink)
  GameTooltip:Show()
end

function Tooltip_OnLeave()
  GameTooltip:Hide()
end

local TitleText = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontNormal")
TitleText:SetPoint("TOP", -28, -3)
TitleText:SetText("NWOP")
local TitleText2 = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontWhite")
TitleText2:SetPoint("TOP", 18, -3)
TitleText2:SetText("-ing for:")

local ItemText2 = NWOPMain:CreateFontString(nil, "OVERLAY", "GameFontWhite")
ItemText2:SetPoint("TOP", 0, -17)
ItemText2:SetText(GlobalItemLink)


local NeedButton = CreateFrame("Button", "NeedButton", NWOPMain)
NeedButton:SetSize(50,50);
NeedButton:SetPoint("LEFT", 20, -10)
NeedButton:SetPushedTexture("Interface\\Buttons\\UI-PlusButton-Down")
NeedButton:SetHighlightTexture("Interface\\Buttons\\UI-PlusButton-Hilight")
NeedButton:SetNormalTexture("Interface\\Buttons\\UI-PlusButton-Up")
NeedButton:SetFrameStrata("TOOLTIP");
NeedButton:EnableMouse(true)
NeedButton:RegisterForClicks("AnyUp");
NeedButton:SetScript("OnMouseUp", function(self, LeftButton) Need() end)
NeedButton:SetScript("OnEnter", function() Tooltip_OnEnter() end)
NeedButton:SetScript("OnLeave", function() Tooltip_OnLeave() end)

local NeedText = NeedButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")
NeedText:SetPoint("CENTER", 0, -30)
NeedText:SetText("NEED")

local WantButton = CreateFrame("Button", "WantButton", NWOPMain)
WantButton:SetSize(50,50);
WantButton:SetPoint("LEFT", 120, -10)
WantButton:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Down")
WantButton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Highlight")
WantButton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Dice-Up")
WantButton:SetFrameStrata("TOOLTIP");
WantButton:EnableMouse(true)
WantButton:RegisterForClicks("AnyUp");
WantButton:SetScript("OnMouseUp", function(self, LeftButton) Want() end)
WantButton:SetScript("OnEnter", function() Tooltip_OnEnter() end)
WantButton:SetScript("OnLeave", function() Tooltip_OnLeave() end)

local WantText = WantButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")
WantText:SetPoint("CENTER", 0, -30)
WantText:SetText("WANT")

local PassButton = CreateFrame("Button", "PassButton", NWOPMain)
PassButton:SetSize(50,50);
PassButton:SetPoint("LEFT", 220, -10)
PassButton:SetPushedTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Down")
PassButton:SetHighlightTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Highlight")
PassButton:SetNormalTexture("Interface\\Buttons\\UI-GroupLoot-Pass-Up")
PassButton:SetFrameStrata("TOOLTIP");
PassButton:EnableMouse(true)
PassButton:RegisterForClicks("AnyUp");
PassButton:RegisterForClicks("AnyUp");
PassButton:SetScript("OnMouseUp", function(self, LeftButton) Pass() end)

local PassText = PassButton:CreateFontString(nil, "OVERLAY", "GameFontWhite")
PassText:SetPoint("CENTER", 0, -30)
PassText:SetText("PASS")

local events = {
	"CHAT_MSG_RAID_WARNING",
}


local function ShowGui()
	ItemText2:SetText(GlobalItemLink)
	NWOPMain:Show()
end




local function CheckMessage(self, event, ...) --Check for incomming raid warnings containing itemlinks 
	if IsInRaid() then
		Method, _, MasterID = GetLootMethod()
		if true then --Method=="master" then)
			local msg, user = ...
			for itemLink in msg:gmatch("|%x+|Hitem:.-|h.-|h|r") do
				local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(itemLink)
				local slotID = GetSlotID(itemEquipLoc,itemType)
				GlobalItemLink = itemLink
				if slotID~=nil then 
					ShowGui()
				end
			end
		end
	end
end
	
	
for _, v in pairs(events) do
	ChatFrame_AddMessageEventFilter(v, CheckMessage)
end